/* AdvancedOptionsPage.cpp:

   Copyright (C) 1996-2006 Christian Schenk

   This file is part of Yap.

   Yap is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
   
   Yap is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.
   
   You should have received a copy of the GNU General Public License
   along with Yap; if not, write to the Free Software Foundation, 59
   Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#include "StdAfx.h"

#include "yap.h"

#include "AdvancedOptionsPage.h"

/* _________________________________________________________________________

   AdvancedOptionsPage Message Map
   _________________________________________________________________________ */

BEGIN_MESSAGE_MAP(AdvancedOptionsPage, CPropertyPage)
  ON_BN_CLICKED(IDC_CHECK_ASSOCIATION,
		&AdvancedOptionsPage::OnClickCheckAssoc)
END_MESSAGE_MAP();

/* _________________________________________________________________________

   AdvancedOptionsPage::AdvancedOptionsPage
   _________________________________________________________________________ */

AdvancedOptionsPage::AdvancedOptionsPage ()
  : CPropertyPage (IDD),
    checkFileTypeAssociations (g_pYapConfig->checkFileTypeAssociations)
{
}

/* _________________________________________________________________________

   AdvancedOptionsPage::DoDataExchange
   _________________________________________________________________________ */

void
AdvancedOptionsPage::DoDataExchange (/*[in]*/ CDataExchange * pDX)
{
  CPropertyPage::DoDataExchange (pDX);
  DDX_Check (pDX, IDC_CHECK_ASSOCIATION, checkFileTypeAssociations);
}

/* _________________________________________________________________________

   AdvancedOptionsPage::OnApply
   _________________________________________________________________________ */

BOOL
AdvancedOptionsPage::OnApply ()
{
  try
    {
      g_pYapConfig->checkFileTypeAssociations =
	(checkFileTypeAssociations ? true : false);
      
      return (CPropertyPage::OnApply());
    }
  catch (const MiKTeXException & e)
    {
      ErrorDialog::DoModal (this, e);
      return (FALSE);
    }
  catch (const exception & e)
    {
      ErrorDialog::DoModal (this, e);
      return (FALSE);
    }
}

/* _________________________________________________________________________

   AdvancedOptionsPage::OnClickCheckAssoc
   _________________________________________________________________________ */

void
AdvancedOptionsPage::OnClickCheckAssoc ()
{
  SetModified (TRUE);
}
